# coding: utf-8

import six

from huaweicloudsdkcore.sdk_response import SdkResponse
from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class ShowSpanSearchResponse(SdkResponse):

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'total': 'int',
        'span_info_list': 'list[ClientSpanInfo]'
    }

    attribute_map = {
        'total': 'total',
        'span_info_list': 'span_info_list'
    }

    def __init__(self, total=None, span_info_list=None):
        r"""ShowSpanSearchResponse

        The model defined in huaweicloud sdk

        :param total: 返回的总数。
        :type total: int
        :param span_info_list: span信息。
        :type span_info_list: list[:class:`huaweicloudsdkapm.v1.ClientSpanInfo`]
        """
        
        super(ShowSpanSearchResponse, self).__init__()

        self._total = None
        self._span_info_list = None
        self.discriminator = None

        if total is not None:
            self.total = total
        if span_info_list is not None:
            self.span_info_list = span_info_list

    @property
    def total(self):
        r"""Gets the total of this ShowSpanSearchResponse.

        返回的总数。

        :return: The total of this ShowSpanSearchResponse.
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        r"""Sets the total of this ShowSpanSearchResponse.

        返回的总数。

        :param total: The total of this ShowSpanSearchResponse.
        :type total: int
        """
        self._total = total

    @property
    def span_info_list(self):
        r"""Gets the span_info_list of this ShowSpanSearchResponse.

        span信息。

        :return: The span_info_list of this ShowSpanSearchResponse.
        :rtype: list[:class:`huaweicloudsdkapm.v1.ClientSpanInfo`]
        """
        return self._span_info_list

    @span_info_list.setter
    def span_info_list(self, span_info_list):
        r"""Sets the span_info_list of this ShowSpanSearchResponse.

        span信息。

        :param span_info_list: The span_info_list of this ShowSpanSearchResponse.
        :type span_info_list: list[:class:`huaweicloudsdkapm.v1.ClientSpanInfo`]
        """
        self._span_info_list = span_info_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShowSpanSearchResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
